unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtDlgs, ExtCtrls,
  uphoto, utrace, uexif, jpeg;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    Photo1: TMenuItem;
    Charger1: TMenuItem;
    Coordonnes1: TMenuItem;
    race1: TMenuItem;
    Charger2: TMenuItem;
    OpenPhotoDialog: TOpenPictureDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Focus1: TMenuItem;
    Dessiner1: TMenuItem;
    N1: TMenuItem;
    Epaisseur1: TMenuItem;
    Couleur1: TMenuItem;
    OpenDialogTrace: TOpenDialog;
    ColorDialogTrace: TColorDialog;
    Enregistrersous1: TMenuItem;
    N2: TMenuItem;
    SavePhotoDialog: TSavePictureDialog;
    N3: TMenuItem;
    Apropos1: TMenuItem;
    procedure Quitter1Click(Sender: TObject);
    procedure Charger1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Focus1Click(Sender: TObject);
    procedure Charger2Click(Sender: TObject);
    procedure Coordonnes1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure Dessiner1Click(Sender: TObject);
    procedure Couleur1Click(Sender: TObject);
    procedure Epaisseur1Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
  private
    { Dclarations prives }
    fSourisX, fSourisY : integer;
  public
    { Dclarations publiques }
    Photo : TPhoto;
    Trace : TTrace;
    Exif : TExif;
  end;

var
  Form1: TForm1;

implementation

uses
  udlgcoordonnees;

{$R *.dfm}

procedure TForm1.Quitter1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Charger1Click(Sender: TObject);
var
  Bitmap : TBitmap;
  ImageJPEG : TJPEGImage;
begin
  if OpenPhotoDialog.Execute then
  begin
    Bitmap:= TBitmap.Create;
    if UpperCase(ExtractFileExt(OpenPhotoDialog.FileName))='.JPG' then
    begin
      ImageJPEG:=TJPEGImage.Create;
      ImageJPEG.loadfromFile(OpenPhotoDialog.FileName);
      Bitmap.Width := ImageJPEG.Width;
      Bitmap.Height := ImageJPEG.Height;
      Bitmap.Canvas.Draw(0,0,ImageJPEG);
      ImageJPEG.Free;
      try
        Exif:=TExif.Create(OpenPhotoDialog.FileName);
        Photo.Focus:=Exif.Focal_35mm;
      except
        showMessage('Impossible de rcuprer les infos EXIF sur la focale');
      end;
    end
    else
      Bitmap.LoadFromFile(OpenPhotoDialog.FileName);
    Photo.Largeur:=Bitmap.Width;
    Photo.Hauteur:=Bitmap.Height;
    Image1.Width:=Bitmap.Width;
    Image1.Height:=Bitmap.Height;
    Image1.Picture.Graphic:=Bitmap;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Photo:=TPhoto.Create;
  Trace:=TTrace.Create;
end;

procedure TForm1.Focus1Click(Sender: TObject);
var
  Value : string;
begin
  Value:=IntToStr(round(Photo.Focus));
  if InputQuery('Focale de la prise de vue',
                'Veuillez indiquer la focale en mm quivalent 24x36',
                Value)
  then begin
    try
      Photo.Focus:=StrToFloat(Value);
    except
      ShowMessage('Focale incorrecte');
    end;
  end;
end;

procedure TForm1.Charger2Click(Sender: TObject);
begin
  if OpenDialogTrace.Execute then
    try
      Trace.LoadFromFile(OpenDialogTrace.FileName);
      ShowMessage(Format('%d points lus',[Trace.NbPoint]));
    except
      ShowMessage('Problme de lecture du fichier');
    end;
end;

procedure TForm1.Coordonnes1Click(Sender: TObject);
begin
  with DlgCoordonnees do
  begin
    EditX.Text:=FloatToStr(Photo.X);
    EditY.Text:=FloatToStr(Photo.Y);
    EditZ.Text:=IntToStr(round(Photo.Z*1000));
    if DlgCoordonnees.ShowModal=mrOk then
    try
      Photo.X:=StrToFloat(EditX.Text);
      Photo.Y:=StrToFloat(EditY.Text);
      Photo.Z:=StrToFloat(EditZ.Text)/1000;
    except
      ShowMessage('Problme  la lecture des valeurs');
    end;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  fSourisX := X;
  fSourisY := Y; 
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  with DlgCoordonnees do
  begin
    EditX.Text:='0';
    EditY.Text:='0';
    EditZ.Text:='0';
    if DlgCoordonnees.ShowModal=mrOk then
    try
      Photo.AddPtRef(StrToFloat(EditX.Text),
                     StrToFloat(EditY.Text),
                     StrToFloat(EditZ.Text)/1000,
                     fSourisX, fSourisY);
    except
      ShowMessage('Problme  la lecture des valeurs');
    end;
  end;
end;

procedure TForm1.Dessiner1Click(Sender: TObject);
begin
  Trace.Dessiner(Image1.Canvas,Photo);
end;

procedure TForm1.Couleur1Click(Sender: TObject);
begin
  ColorDialogTrace.Color:=Trace.Couleur;
  if ColorDialogTrace.Execute then
    Trace.Couleur:=ColorDialogTrace.Color;
end;

procedure TForm1.Epaisseur1Click(Sender: TObject);
var
  Value : string;
begin
  Value:=IntToStr(Trace.Epaisseur);
  if InputQuery('Epaisseur',
                'Veuillez indiquer l''paisseur du trait en pixel',
                Value)
  then begin
    try
      Trace.Epaisseur:= StrToInt(Value);
    except
      ShowMessage('Epaisseur incorrecte');
    end;
  end;
end;

procedure TForm1.Enregistrersous1Click(Sender: TObject);
begin
  if SavePhotoDialog.Execute then
    Image1.Picture.SaveToFile(SavePhotoDialog.FileName);
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
  ShowMessage('Trace 3D par Eric SIBERT'#13#10'http://www.ericsibert.com'#13#10'Licence GPL'#13#10'exif_dll par Paul-Henri Giraud');
end;

end.
