unit uexif;

interface

uses
  SysUtils, Classes, Windows;

type

    TExif = class
    private
      FFileName : TFileName;
    public
      constructor Create(FileName : TFileName);
      destructor Destroy; override;
      function Focal_35mm : real;
    end;

implementation

uses
  exif_dll;

{ TExif }

constructor TExif.Create(FileName: TFileName);
begin
  inherited Create;
  FFileName := FileName;
end;


destructor TExif.Destroy;
begin
  inherited Destroy;
end;

function TExif.Focal_35mm : real;
var
  XRes, YRes, Focale : real;
  XWidth, YWidth, Direct : integer;
begin
  if read_file(PChar(FFileName)) then
  begin
    Direct:=get_focal_length_35_mm;
    if Direct=-1 then // quivalence non gre
    begin
      XRes:=get_focal_plane_X_resolution;
      YRes:=get_focal_plane_Y_resolution;
      XWidth:=get_Image_Width;
      YWidth:=get_image_height;
      Focale:=get_focal_length;
      if (XRes=-1.0) or (YRes=-1.0) or (XWidth=-1) or (YWidth=-1) or (Focale=-1.0) then
        Raise Exception.Create('No enougth exif data');
      result:=(36*XRes/XWidth+24*YRes/YWidth)/2/25.4*Focale;
      case get_focal_plane_resolution_unit of
        1 : result:=(36*XRes/XWidth+24*YRes/YWidth)/2*Focale;
        2 : result:=(36*XRes/XWidth+24*YRes/YWidth)/2/25.4*Focale;
      else
        Raise Exception.Create('focal plane resolution unit unknown');
      end;
    end
    else
      Result:=Direct;
  end
  else
    Raise Exception.Create('No exif data');
end;


end.
